; Include file for the neural network object by Thomas Bleeker. http://www.MadWizard.org
; (C)2002 by Thomas Bleeker

NNETINFO_MEMUSE			equ	1			; Total memory use of network data
NNETINFO_TOTALNEURONS	equ	2			; Total number of neurons in network
NNETINFO_CONNECTIONS	equ	3			; Total number of connections in network
NNETINFO_SERDATASIZE	equ	4			; Total data size of serialized network (for save method)

NNETFLAG_TOFILE			equ	1			; Output data to file, outData is file handle
NNETFLAG_TOMEM			equ	2			; Output data to memory, outData is pointer to memory

NNETFLAG_FROMFILE		equ	4			; Read data from file, inData is file handle
NNETFLAG_FROMMEM		equ	8			; Read data from mem, inData is mem pointer


NNETERR_NOERROR			equ	0			; No error has occurred
NNETERR_INVALIDPARAM	equ	1			; Invalid parameter
NNETERR_FILEACCESS		equ	2			; File access failed (write or read)
NNETERR_INVALIDDATA		equ 3			; Invalid serialized data

NNINFO	STRUCT
	nInputs			dd		? 	; Number of inputs
	nOutputs		dd		?	; Number of outputs
	nHiddenLayers	dd		?	; Number of hidden layers
	nHiddenNeurons	dd		?	; Number of neurons in one hidden layer
NNINFO	ENDS

NNETSERIAL_HEADER	STRUCT
	dwMagic		dd		?		;always "NNET" as dword (4E4E4554h)
	lnWeights	dd		?		;size of weight array
NNETSERIAL_HEADER	ENDS



RAND32		PROTO	:DWORD
InitRand32  PROTO
; random number generator by NaN
; (modified a bit to make it a procedure by Exagone)
.data? 
	NaNRand dd ?
.code

SWAP MACRO M1:REQ, M2:REQ
	xor M1, M2
	xor M2, M1
	xor M1, M2
ENDM

InitRand32	proc
  db 0fh,31h 
  shr eax, 2
  add eax, 1
  mov NaNRand, eax
ret
InitRand32 endp  
  
RAND32 proc base:DWORD
  ; Random number generator based on the Real time clock
  ; and the Park, Miller random number algorithm
  ;
  ; Coded by NaN for WIN32ASM
  ; May 5, 2001
  ; rev 2.
  push ecx
  push edx


  mov eax, NaNRand    
  mov edx,0
  mov ecx, 127773 ;q
  div ecx      ; eax == floor( seed / q)
               ; edx == remainder
  SWAP eax, edx
  push edx
  mov ecx, 16807
  mul ecx      ; eax = mul of remainder * a
  pop edx      ; edx == floor of seed/q
  
  SWAP eax, edx
  push edx
  mov ecx, 2836
  mul ecx
  pop edx      ; edx == mull of rem * a
               ; eax == mull of seed/q * r
               
  sub edx, eax
  mov eax, edx    
  mov NaNRand, eax ; save next seed 
  mov ecx, base
  mov edx, 0
  div ecx
  mov eax, edx
  pop edx
  pop ecx
 ret
RAND32 endp

.data?
	MaskedCW	dw	?
	SaveCW		dw	?
.code
; The expval macro is almost entirly based on code from
; Randall Hyde's art of assembly.
EXPVAL	MACRO	
    fldl2e          ;Put lg(e) onto the stack.
    fmulp st(1),st(0)      ;Compute x*lg(e).
    
    fstcw  	SaveCW

; Modify the control word to truncate when rounding.

    fstcw   MaskedCW
    or      byte ptr [MaskedCW+1], 1100b
    fldcw   MaskedCW

    fld     st(0)           ;Duplicate tos.
    fld     st(0)
    frndint                 ;Compute integer portion.

    fxch                    ;Swap whole and int values.
    fsub    st(0), st(1)    ;Compute fractional part.

    f2xm1                   ;Compute 2**frac(x)-1.
    fld1
    fadd                    ;Compute 2**frac(x).

    fxch                    ;Get integer portion.
    fld1                    ;Compute 1*2**int(x).
    fscale
    fstp    st(1)           ;Remove st(1) (which is 1).

    fmulp 	st(1),st(0)	    ;Compute 2**int(x) * 2**frac(x).
    fstp	st(1)
    fldcw   SaveCW     		;Restore rounding mode.
ENDM


